/********
* ec2c version 0.67
* c file generated for node : modes3x2 
* context   method = STATIC
* ext call  method = PROCEDURES
********/
/* This program needs external declarations */
#define _modes3x2_EC2C_SRC_FILE
#include "modes3x2.h"
/*--------

 * the following functions must be defined:

extern void A0(_integer*, _integer*_integer);
extern void A1(_integer*, _integer*_integer);
extern void A2(_integer*, _integer*_integer);
extern void B0(_integer*, _integer*_integer);
extern void B1(_integer*, _integer*_integer);
--------*/
/*--------
Internal structure for the call
--------*/
typedef struct  {
   
   //INPUTS
   _integer _x;
   _boolean _on_off;
   _boolean _toggle;
   //OUTPUTS
   _integer _res;
   //REGISTERS
   _integer M54;
/*
LUSREG:M54
pre(V49_z)
LUSEND
*/
   _boolean M54_nil;
   _integer M52;
   _boolean M52_nil;
   _integer M48;
   _boolean M48_nil;
   _boolean M42;
/*
LUSREG:M42
pre(V162_sby)
LUSEND
*/
   _boolean M42_nil;
   _boolean M45;
/*
LUSREG:M45
pre(V161_nom)
LUSEND
*/
   _boolean M45_nil;
   _integer M38;
/*
LUSREG:M38
pre(V48_y)
LUSEND
*/
   _boolean M38_nil;
   _integer M35;
   _boolean M35_nil;
   _integer M31;
   _boolean M31_nil;
   _boolean M25;
/*
LUSREG:M25
pre(V148_high)
LUSEND
*/
   _boolean M25_nil;
   _boolean M18;
/*
LUSREG:M18
pre(V147_low)
LUSEND
*/
   _boolean M18_nil;
   _integer M13;
   _boolean M13_nil;
   _boolean M9;
/*
LUSREG:M9
pre(V146_idle)
LUSEND
*/
   _boolean M9_nil;
   _boolean M7;
/*
LUSREG:M7
init(true)
LUSEND
*/
} modes3x2_ctx;

// Single Static Context
static modes3x2_ctx ctx;
/*--------
Output procedures must be defined,
Input procedures must be used:
--------*/
void modes3x2_I_x(_integer V){
   ctx._x = V;
}
void modes3x2_I_on_off(_boolean V){
   ctx._on_off = V;
}
void modes3x2_I_toggle(_boolean V){
   ctx._toggle = V;
}
extern void modes3x2_O_res(_integer);
#ifdef CKCHECK
extern void modes3x2_BOT_res();
#endif
/*--------
Internal reset input procedure
--------*/
static void modes3x2_reset_input(){
   //NOTHING FOR THIS VERSION...
}
/*--------
Reset procedure
--------*/
void modes3x2_reset(){
   ctx.M54_nil = _true;
   ctx.M52_nil = _true;
   ctx.M48_nil = _true;
   ctx.M42_nil = _true;
   ctx.M45_nil = _true;
   ctx.M38_nil = _true;
   ctx.M35_nil = _true;
   ctx.M31_nil = _true;
   ctx.M25_nil = _true;
   ctx.M18_nil = _true;
   ctx.M13_nil = _true;
   ctx.M9_nil = _true;
   ctx.M7 = _true;
   modes3x2_reset_input();
}
/*--------
Step procedure
--------*/
void modes3x2_step(){
//LOCAL VARIABLES
   _boolean L6;
/*
LUSDEF:L6
(true)->(pre(V146_idle))
LUSEND
*/
   _boolean L10;
/*
LUSDEF:L10
not(on_off)
LUSEND
*/
   _boolean L5;
/*
LUSDEF:L5
 if (V149_pidle) then (not(on_off)) else (on_off)
LUSEND
*/
   _integer L12_0;
   _integer L11;
/*
LUSDEF:L11
current(A0((x)when(V146_idle)))
LUSEND
*/
   _boolean L16;
/*
LUSDEF:L16
(false)->(pre(V147_low))
LUSEND
*/
   _boolean L20;
/*
LUSDEF:L20
(on_off)or(toggle)
LUSEND
*/
   _boolean L19;
/*
LUSDEF:L19
not((on_off)or(toggle))
LUSEND
*/
   _boolean L22;
/*
LUSDEF:L22
(V149_pidle)and(on_off)
LUSEND
*/
   _boolean L24;
/*
LUSDEF:L24
(false)->(pre(V148_high))
LUSEND
*/
   _boolean L23;
/*
LUSDEF:L23
(V151_phigh)and(toggle)
LUSEND
*/
   _boolean L21;
/*
LUSDEF:L21
((V149_pidle)and(on_off))or((V151_phigh)and(toggle))
LUSEND
*/
   _boolean L15;
/*
LUSDEF:L15
 if (V150_plow) then (not((on_off)or(toggle))) else (((V149_pidle)and(on_off))
or((V151_phigh)and(toggle)))
LUSEND
*/
   _integer L30_0;
   _integer L29;
/*
LUSDEF:L29
current(A1((x)when(V147_low)))
LUSEND
*/
   _boolean L28;
/*
LUSDEF:L28
(V150_plow)and(not(on_off))
LUSEND
*/
   _boolean L27;
/*
LUSDEF:L27
((V150_plow)and(not(on_off)))and(toggle)
LUSEND
*/
   _boolean L26;
/*
LUSDEF:L26
 if (V151_phigh) then (not((on_off)or(toggle))) else (((V150_plow)and(not(
on_off)))and(toggle))
LUSEND
*/
   _integer L34_0;
   _integer L33;
/*
LUSDEF:L33
current(A2((x)when(V148_high)))
LUSEND
*/
   _integer L36;
/*
LUSDEF:L36
(0)->(pre(V48_y))
LUSEND
*/
   _integer L32;
/*
LUSDEF:L32
 if (V148_high) then (current(A2((x)when(V148_high)))) else ((0)->(pre(V48_y)))
LUSEND
*/
   _integer L14;
/*
LUSDEF:L14
 if (V147_low) then (current(A1((x)when(V147_low)))) else ( if (V148_high
) then (current(A2((x)when(V148_high)))) else ((0)->(pre(V48_y))))
LUSEND
*/
   _integer L4;
/*
LUSDEF:L4
 if (V146_idle) then (current(A0((x)when(V146_idle)))) else ( if (V147_low
) then (current(A1((x)when(V147_low)))) else ( if (V148_high) then (current(A2(
(x)when(V148_high)))) else ((0)->(pre(V48_y)))))
LUSEND
*/
   _boolean L41;
/*
LUSDEF:L41
(false)->(pre(V162_sby))
LUSEND
*/
   _boolean L40;
/*
LUSDEF:L40
(on_off)=((false)->(pre(V162_sby)))
LUSEND
*/
   _integer L47_0;
   _integer L46;
/*
LUSDEF:L46
current(B0((V48_y)when(V161_nom)))
LUSEND
*/
   _boolean L44;
/*
LUSDEF:L44
(true)->(pre(V161_nom))
LUSEND
*/
   _boolean L43;
/*
LUSDEF:L43
(on_off)=((true)->(pre(V161_nom)))
LUSEND
*/
   _integer L51_0;
   _integer L50;
/*
LUSDEF:L50
current(B1((V48_y)when(V162_sby)))
LUSEND
*/
   _integer L53;
/*
LUSDEF:L53
(0)->(pre(V49_z))
LUSEND
*/
   _integer L49;
/*
LUSDEF:L49
 if (V162_sby) then (current(B1((V48_y)when(V162_sby)))) else ((0)->(pre(V49_z)
))
LUSEND
*/
   _integer L39;
/*
LUSDEF:L39
 if (V161_nom) then (current(B0((V48_y)when(V161_nom)))) else ( if (V162_sby
) then (current(B1((V48_y)when(V162_sby)))) else ((0)->(pre(V49_z))))
LUSEND
*/
   _integer L3;
/*
LUSDEF:L3
(V48_y)+(V49_z)
LUSEND
*/
   _integer T54;
/*
LUSDEF:T54
pre(V49_z)
LUSEND
*/
   _integer T52;
   _integer T48;
   _boolean T42;
/*
LUSDEF:T42
pre(V162_sby)
LUSEND
*/
   _boolean T45;
/*
LUSDEF:T45
pre(V161_nom)
LUSEND
*/
   _integer T38;
/*
LUSDEF:T38
pre(V48_y)
LUSEND
*/
   _integer T35;
   _integer T31;
   _boolean T25;
/*
LUSDEF:T25
pre(V148_high)
LUSEND
*/
   _boolean T18;
/*
LUSDEF:T18
pre(V147_low)
LUSEND
*/
   _integer T13;
   _boolean T9;
/*
LUSDEF:T9
pre(V146_idle)
LUSEND
*/
//CODE
   if (ctx.M7) {
      L6 = _true;
   } else {
      L6 = ctx.M9;
   }
   L10 = (! ctx._on_off);
   if (L6) {
      L5 = L10;
   } else {
      L5 = ctx._on_off;
   }
   if(L5) {
      A0(&L12_0, ctx._x);
   }
   if (L5) {
      L11 = L12_0;
   } else {
      L11 = ctx.M13;
   }
   if (ctx.M7) {
      L16 = _false;
   } else {
      L16 = ctx.M18;
   }
   L20 = (ctx._on_off | ctx._toggle);
   L19 = (! L20);
   L22 = (L6 & ctx._on_off);
   if (ctx.M7) {
      L24 = _false;
   } else {
      L24 = ctx.M25;
   }
   L23 = (L24 & ctx._toggle);
   L21 = (L22 | L23);
   if (L16) {
      L15 = L19;
   } else {
      L15 = L21;
   }
   if(L15) {
      A1(&L30_0, ctx._x);
   }
   if (L15) {
      L29 = L30_0;
   } else {
      L29 = ctx.M31;
   }
   L28 = (L16 & L10);
   L27 = (L28 & ctx._toggle);
   if (L24) {
      L26 = L19;
   } else {
      L26 = L27;
   }
   if(L26) {
      A2(&L34_0, ctx._x);
   }
   if (L26) {
      L33 = L34_0;
   } else {
      L33 = ctx.M35;
   }
   if (ctx.M7) {
      L36 = 0;
   } else {
      L36 = ctx.M38;
   }
   if (L26) {
      L32 = L33;
   } else {
      L32 = L36;
   }
   if (L15) {
      L14 = L29;
   } else {
      L14 = L32;
   }
   if (L5) {
      L4 = L11;
   } else {
      L4 = L14;
   }
   if (ctx.M7) {
      L41 = _false;
   } else {
      L41 = ctx.M42;
   }
   L40 = (ctx._on_off == L41);
   if(L40) {
      B0(&L47_0, L4);
   }
   if (L40) {
      L46 = L47_0;
   } else {
      L46 = ctx.M48;
   }
   if (ctx.M7) {
      L44 = _true;
   } else {
      L44 = ctx.M45;
   }
   L43 = (ctx._on_off == L44);
   if(L43) {
      B1(&L51_0, L4);
   }
   if (L43) {
      L50 = L51_0;
   } else {
      L50 = ctx.M52;
   }
   if (ctx.M7) {
      L53 = 0;
   } else {
      L53 = ctx.M54;
   }
   if (L43) {
      L49 = L50;
   } else {
      L49 = L53;
   }
   if (L40) {
      L39 = L46;
   } else {
      L39 = L49;
   }
   L3 = (L4 + L39);
   modes3x2_O_res(L3);
   T54 = L39;
   T52 = L51_0;
   T48 = L47_0;
   T42 = L43;
   T45 = L40;
   T38 = L4;
   T35 = L34_0;
   T31 = L30_0;
   T25 = L26;
   T18 = L15;
   T13 = L12_0;
   T9 = L5;
   ctx.M54 = T54;
   ctx.M54_nil = _false;
   if(L43) {ctx.M52 = T52;
      ctx.M52_nil = _false;
   }
   if(L40) {ctx.M48 = T48;
      ctx.M48_nil = _false;
   }
   ctx.M42 = T42;
   ctx.M42_nil = _false;
   ctx.M45 = T45;
   ctx.M45_nil = _false;
   ctx.M38 = T38;
   ctx.M38_nil = _false;
   if(L26) {ctx.M35 = T35;
      ctx.M35_nil = _false;
   }
   if(L15) {ctx.M31 = T31;
      ctx.M31_nil = _false;
   }
   ctx.M25 = T25;
   ctx.M25_nil = _false;
   ctx.M18 = T18;
   ctx.M18_nil = _false;
   if(L5) {ctx.M13 = T13;
      ctx.M13_nil = _false;
   }
   ctx.M9 = T9;
   ctx.M9_nil = _false;
   ctx.M7 = ctx.M7 && !(_true);
}
